package com.logicbig.example;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;
import java.util.List;

public class ExampleMain2 {

    public static void main(String[] args) {
        EntityManagerFactory emf = Persistence.createEntityManagerFactory("test");
        try {
            persistEntity(emf);
            runNativeQueries(emf);
            loadEntity(emf);
        } finally {
            emf.close();
        }
    }

    private static void persistEntity(EntityManagerFactory emf) {
        System.out.println("-- Persisting entities --");
        EntityManager em = emf.createEntityManager();

        EntityA entityA = new EntityA();
        ClassA a = new ClassA();
        a.setMyInt(10);
        a.setMyStr("a test String");
        entityA.setClassARef(a);

        System.out.println(entityA);

        em.getTransaction().begin();
        em.persist(entityA);
        em.getTransaction().commit();
        em.close();
    }

    private static void runNativeQueries(EntityManagerFactory emf) {
        System.out.println("-- native queries --");
        EntityManager em = emf.createEntityManager();
        ExampleMain.nativeQuery(em, "Select * from EntityA");
    }

    private static void loadEntity(EntityManagerFactory emf) {
        System.out.println("-- Loading EntityA --");
        EntityManager em = emf.createEntityManager();
        List<EntityA> entityAList = em.createQuery("Select t from EntityA t")
                                      .getResultList();
        entityAList.forEach(System.out::println);
        em.close();
    }
}